import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Modal, Upload ,Popconfirm,Checkbox} from 'antd';
import ApproveOrderDetaile from "./approveOrderDetaile.jsx";
import moment from 'moment';
import '../../userMangagement.less';
import {orderState,paymentState,orderChannel} from '../../../../dataDic.js';
import {getOrderState,getPaymentState,getOrderChannel,getProjectState,getApprovedState,getOrderType } from '../../../../tools.js';

const ApproveOrder=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/listApprovalServiceOrder',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                buyerName:this.state.customerName,
                startDate: this.state.releaseDate[0],
				endDate: this.state.releaseDate[1],
				depIds:this.state.departmentSearch , //部门
				salesmanName:this.state.orderLeader, //负责人
				orderStatus:this.state.orderStateSearch , //订单状态
				liquidationStatus:this.state.paymentStateSearch , //结算状态
				orderChannel:this.state.orderChannelSearch, //订单渠道
				approvalHistory:this.state.approvalHistorySearch?1:0    //特批历史
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
	                        id: thisdata.id,
	                        orderNo: thisdata.orderNo,
	                        orderType:thisdata.orderType,
	                        orderStatus:thisdata.orderStatus,
	                        liquidationStatus:thisdata.liquidationStatus,
	                        createTime:thisdata.createTime,
	                        buyerName:thisdata.buyerName,
	                        signTotalAmount:thisdata.signTotalAmount,
	                        projectStage:thisdata.projectStage,
	                        approval:thisdata.approval,
	                        salesmanName:thisdata.salesmanName,
		                    orderChannel:thisdata.orderChannel,
		                    financeName:thisdata.financeName,
		                    departmentName:thisdata.departmentName
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                	pageNo:pageNo,
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[]
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    departmentList() {
		this.setState({
			loading: true
		});
		$.ajax({
			method: "post",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context + "/api/admin/organization/selectSuperId",
			data: {
				
			},
			success: function(data) {
				let thedata = data.data;
				let theArr=[];
				if(!thedata) {
					if(data.error && data.error.length) {
						message.warning(data.error[0].message);
					};
					thedata = {};
				}else{
					thedata.map(function(item,index){
						theArr.push({
							key:index,
							name:item.name,
							id:item.id,
							depNo:item.depNo
						})
					})
				}
				this.setState({
					departmentArr:theArr,
				})
			}.bind(this),
			}).always(function() {
				this.setState({
					loading: false
				});
			}.bind(this));
	},
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            releaseDate: [],
            selectedRows: [],
            approvalHistorySearch:true,
            searchMore: true,
            loading: false,
            distributionVisible:false,
            intentOrder:false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            distributionPagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.contactList(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo'
                }, {
                    title: '订单类型',
                    dataIndex: 'orderType',
                    key: 'orderType',
                    render:(text)=>{return getOrderType(text)}
                }, {
                    title: '下单时间',
                    dataIndex: 'createTime',
                    key: 'createTime'
                },{
                    title: '订单客户',
                    dataIndex: 'buyerName',
                    key: 'buyerName',
                    render:(text)=>{return (text.length>8)?(text).substr(0,8)+'…':text}
                },
                {
                    title: '实际下单金额',
                    dataIndex: 'signTotalAmount',
                    key: 'signTotalAmount'
                }, {
                    title: '结算状态',
                    dataIndex: 'liquidationStatus',
                    key: 'liquidationStatus',
                    render:(text)=>{return getPaymentState(text) }
                }, {
                    title: '订单状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                    render:(text)=>{return getOrderState(text) }
                }, {
                    title: '项目状态',
                    dataIndex: 'projectStage',
                    key: 'projectStage',
                    render:(text)=>{return getProjectState(text) }
                },{
                    title: '是否特批',
                    dataIndex: 'approval',
                    key: 'approval',
                    render:text=>{return text==2?'已特批':'未特批'}
                },{
                    title: '订单渠道',
                    dataIndex: 'orderChannel',
                    key: 'orderChannel',
                    render:(text)=>{return getOrderChannel(text) }
                },{
                    title: '部门机构',
                    dataIndex: 'departmentName',
                    key: 'departmentName',
                },{
                    title: '订单跟进人',
                    dataIndex: 'salesmanName',
                    key: 'salesmanName',
                },{
                    title: '财务跟进人',
                    dataIndex: 'financeName',
                    key: 'financeName',
                },{
                    title: '操作',
                    dataIndex: 'operation',
                    key: 'operation',
                    render: (text, record, index) => {
						return <div>
									{record.approval==1&&<div>
										<Popconfirm title={'您确认驳回 【'+ record.salesmanName +'】的特批申请？'} onConfirm={(e)=>{this.reject(record)}} okText="确认" cancelText="取消">
										    <Button style={{marginRight:'5px'}} type="danger" onClick={(e) =>{ e.stopPropagation()}}>驳回</Button>                 
										</Popconfirm>
										<Popconfirm title={'您确定同意 【'+ record.salesmanName +'】的特批申请？'} onConfirm={(e)=>{this.confirm(record)}} okText="确认" cancelText="取消">
										    <Button style={{marginRight:'5px'}} type="primary" onClick={(e) =>{ e.stopPropagation()}}>同意</Button>                 
										</Popconfirm>
									</div>}
                        	   </div>
					}
                }
            ],
            dataSource: [],
        };
    },
    //操作分配
    confirmDelet(index){
    	this.setState({
    		userDetaile:false,
    	});
    	this.contactList(1,index.id)
    },
    //驳回
    reject(record){
    	this.confirmSelect(0,record)
    },
    //确认
    confirm(record){
    	this.confirmSelect(1,record)
    },
    confirmSelect(nub,record){
    	this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/approvalServiceOrder',
            data: {
            	orderNo:record.orderNo,
            	confirm:nub
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功');
                this.setState({
                    loading: false,
                });
                 this.loadData();
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    componentWillMount() {
        this.loadData();
        this.departmentList()
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.pageNo);
        };
    },
    searchSwitch() {
		this.setState({
			searchMore: !this.state.searchMore
		});
	},
    search() {
        this.loadData();
    },
    //分配时搜索
    searchOrder() {
        this.contactList();
    },
    //分配时重置
    resetOrder() {
        this.contactList();
    },
    reset() {
    	this.state.customerName='';
    	this.state.releaseDate[0] = undefined;
		this.state.releaseDate[1] = undefined;
		this.state.orderLeader = '';
		this.state.departmentSearch=undefined;
		this.state.approvalHistorySearch=true;
		this.state.orderStateSearch  = undefined;
		this.state.paymentStateSearch  = undefined;
        this.loadData();       
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        let departmentArr = this.state.departmentArr || [];
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>特批订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.customerName}
	                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />
	                    <RangePicker
		                        value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
		                        this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
		                        onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} /> 
                        <Select placeholder="部门机构"
	                        style={{ width: 150 ,marginRight:'10px',marginLeft:'10px'}}
	                        value={this.state.departmentSearch}
	                        onChange={(e) => { this.setState({ departmentSearch: e }) }}>
	                        {
	                            departmentArr.map(function (item) {
	                                    return <Select.Option key={item.id} >{item.name}</Select.Option>
	                            })
	                        }
                  		</Select>
                  		<Input placeholder="订单负责人" style={{width:'150px'}}
	                        value={this.state.orderLeader}
	                        onChange={(e) => { this.setState({ orderLeader: e.target.value }); }} />
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}> 
	                  		<Checkbox checked={this.state.approvalHistorySearch} onChange={(e)=>{this.setState({approvalHistorySearch:!this.state.approvalHistorySearch})}}>特批历史订单</Checkbox>
	                        <Select placeholder="订单状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.orderStateSearch}
	                            onChange={(e) => { this.setState({ orderStateSearch: e }) }}>
	                            {
                                    orderState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="结算状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.paymentStateSearch}
	                            onChange={(e) => { this.setState({ paymentStateSearch: e }) }}>
	                            {
                                    paymentState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <ApproveOrderDetaile
	                	confirmDelet={this.confirmDelet}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
            </div>
        );
    }
}));

export default ApproveOrder;

